/**
 */
package de.mdelab.mlsdm.interpreter.coverage.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.interpreter.coverage.ActivityCoverageReport;
import de.mdelab.mlsdm.interpreter.coverage.CoverageEntry;
import de.mdelab.mlsdm.interpreter.coverage.CoveragePackage;
import de.mdelab.mlsdm.interpreter.coverage.CoverageReport;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Report</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.interpreter.coverage.impl.CoverageReportImpl#getActivityCoverageReports <em>Activity Coverage Reports</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.interpreter.coverage.impl.CoverageReportImpl#getTotalCoverage <em>Total Coverage</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CoverageReportImpl extends MLElementWithUUIDImpl implements CoverageReport
{
	/**
	 * The cached value of the '{@link #getActivityCoverageReports()
	 * <em>Activity Coverage Reports</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getActivityCoverageReports()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityCoverageReport>	activityCoverageReports;

	/**
	 * The default value of the '{@link #getTotalCoverage() <em>Total Coverage</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getTotalCoverage()
	 * @generated
	 * @ordered
	 */
	protected static final double			TOTAL_COVERAGE_EDEFAULT	= 0.0;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected CoverageReportImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return CoveragePackage.Literals.COVERAGE_REPORT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ActivityCoverageReport> getActivityCoverageReports()
	{
		if (activityCoverageReports == null)
		{
			activityCoverageReports = new EObjectContainmentEList<ActivityCoverageReport>(ActivityCoverageReport.class, this,
					CoveragePackage.COVERAGE_REPORT__ACTIVITY_COVERAGE_REPORTS);
		}
		return activityCoverageReports;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public double getTotalCoverage()
	{
		double totalElements = 0;
		double coveredElements = 0;

		for (final ActivityCoverageReport acr : this.getActivityCoverageReports())
		{
			totalElements += acr.getCoverageEntries().size();

			for (final CoverageEntry entry : acr.getCoverageEntries())
			{
				if (entry.getExecutions() > 0)
				{
					coveredElements++;
				}
			}
		}

		return coveredElements / totalElements;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case CoveragePackage.COVERAGE_REPORT__ACTIVITY_COVERAGE_REPORTS:
				return ((InternalEList<?>) getActivityCoverageReports()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID)
		{
			case CoveragePackage.COVERAGE_REPORT__ACTIVITY_COVERAGE_REPORTS:
				return getActivityCoverageReports();
			case CoveragePackage.COVERAGE_REPORT__TOTAL_COVERAGE:
				return getTotalCoverage();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID)
		{
			case CoveragePackage.COVERAGE_REPORT__ACTIVITY_COVERAGE_REPORTS:
				getActivityCoverageReports().clear();
				getActivityCoverageReports().addAll((Collection<? extends ActivityCoverageReport>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID)
		{
			case CoveragePackage.COVERAGE_REPORT__ACTIVITY_COVERAGE_REPORTS:
				getActivityCoverageReports().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID)
		{
			case CoveragePackage.COVERAGE_REPORT__ACTIVITY_COVERAGE_REPORTS:
				return activityCoverageReports != null && !activityCoverageReports.isEmpty();
			case CoveragePackage.COVERAGE_REPORT__TOTAL_COVERAGE:
				return getTotalCoverage() != TOTAL_COVERAGE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

} // CoverageReportImpl
