/**
 */
package de.mdelab.mlsdm.interpreter.coverage.util;

import de.mdelab.mlcore.MLElementWithUUID;

import de.mdelab.mlsdm.interpreter.coverage.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see de.mdelab.mlsdm.interpreter.coverage.CoveragePackage
 * @generated
 */
public class CoverageAdapterFactory extends AdapterFactoryImpl
{
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static CoveragePackage	modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CoverageAdapterFactory()
	{
		if (modelPackage == null)
		{
			modelPackage = CoveragePackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object)
	{
		if (object == modelPackage)
		{
			return true;
		}
		if (object instanceof EObject)
		{
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CoverageSwitch<Adapter>	modelSwitch	= new CoverageSwitch<Adapter>()
													{
														@Override
														public Adapter caseCoverageReport(CoverageReport object)
														{
															return createCoverageReportAdapter();
														}

														@Override
														public Adapter caseCoverageEntry(CoverageEntry object)
														{
															return createCoverageEntryAdapter();
														}

														@Override
														public Adapter caseActivityCoverageReport(ActivityCoverageReport object)
														{
															return createActivityCoverageReportAdapter();
														}

														@Override
														public Adapter caseMLElementWithUUID(MLElementWithUUID object)
														{
															return createMLElementWithUUIDAdapter();
														}

														@Override
														public Adapter defaultCase(EObject object)
														{
															return createEObjectAdapter();
														}
													};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target)
	{
		return modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlsdm.interpreter.coverage.CoverageReport <em>Report</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.interpreter.coverage.CoverageReport
	 * @generated
	 */
	public Adapter createCoverageReportAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlsdm.interpreter.coverage.CoverageEntry <em>Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.interpreter.coverage.CoverageEntry
	 * @generated
	 */
	public Adapter createCoverageEntryAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlsdm.interpreter.coverage.ActivityCoverageReport <em>Activity Coverage Report</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlsdm.interpreter.coverage.ActivityCoverageReport
	 * @generated
	 */
	public Adapter createActivityCoverageReportAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.mdelab.mlcore.MLElementWithUUID <em>ML Element With UUID</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.mdelab.mlcore.MLElementWithUUID
	 * @generated
	 */
	public Adapter createMLElementWithUUIDAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter()
	{
		return null;
	}

} //CoverageAdapterFactory
