package de.mdelab.mlsdm.interpreter.notifications;

import java.io.OutputStream;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.interpreter.facade.MLSDMMetamodelFacadeFactory;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.notifications.OutputStreamNotificationReceiver;

/**
 * Receives notifications and prints them on the specified output stream or
 * System.out.
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMOutputStreamNotificationReceiver
		extends
		OutputStreamNotificationReceiver<Activity, ActivityNode, ActivityEdge, StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression>
{

	public MLSDMOutputStreamNotificationReceiver(final OutputStream outputStream)
	{
		super(MLSDMMetamodelFacadeFactory.INSTANCE, outputStream);
	}

	public MLSDMOutputStreamNotificationReceiver()
	{
		super(MLSDMMetamodelFacadeFactory.INSTANCE);
	}

}
